package com.example.eatwell.view

import android.util.Log
import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import com.example.eatwell.Resources
import com.example.eatwell.domain.Constant
import com.example.eatwell.model.Category
import com.example.eatwell.model.Diets
import com.example.eatwell.model.Ingredients
import com.example.eatwell.model.Recipes

import io.github.jan.supabase.gotrue.auth
import io.github.jan.supabase.gotrue.providers.builtin.Email
import io.github.jan.supabase.postgrest.from
import kotlinx.coroutines.launch

class MainViewModel():ViewModel() {

    fun onSignInEmailPassword(emailUser: String, passwordUser: String) {
        viewModelScope.launch {
            try {
                val user = Constant.supabase.auth.signInWith(Email) {
                    email = emailUser
                    password = passwordUser
                }
                    //  println(user.toString())
                Log.d("Логин: ", user.toString())
               // println(Constant.supabase.auth.currentUserOrNull()!!.id)
                println("Success")
                Log.d("Логин",Constant.supabase.auth.currentUserOrNull()!!.id )
            } catch (e: Exception) {
                println("Error)))))))")
                Log.d("Ошибка: ", e.message.toString())
                println(e.message.toString())
            }
        }
    }
    fun onSignUpEmail(emailUser: String, passwordUser: String) {
        viewModelScope.launch {
            try{
                var  user =  Constant.supabase.auth.signUpWith(Email) {
                    email = emailUser
                    password = passwordUser
                }
                println(user.toString())
                println(Constant.supabase.auth.currentUserOrNull()!!.id)
                println("Success")

            }
            catch (e: Exception) {
                println("Error")
                println(e.message.toString())
            }

        }
    }

    fun getRecipes(){

        viewModelScope.launch {
            try {
                Resources.recipes = Constant.supabase.from("Recipes").select { "*" }
                    .decodeList<Recipes>() as ArrayList<Recipes>
                Log.d("Список: ", " " + Resources.recipes)
            } catch (e: Exception) {
                Log.e("Ошибка: ", e.message.toString())
            }
        }
    }

    fun getRecipes(categoryId: Int, dietId: Int): List<Recipes>{
        var recipesList: List<Recipes>
        recipesList = ArrayList()
        viewModelScope.launch {
            try{
             recipesList = Constant.supabase.from("Recipes").select(){ filter {

                 Recipes::category eq categoryId
                 Recipes::diets eq dietId
             } }.decodeList<Recipes>()
           Log.d("Список по категории: ", recipesList.toString())
            }
            catch (e: Exception){
                Log.e("Ошибка: ", e.message.toString())
            }
        }
        return recipesList;
    }

    fun getDiets(){
        viewModelScope.launch {
            try{
                Resources.diets = Constant.supabase.from("Diets").select { "*" }.decodeList<Diets>() as ArrayList<Diets>
                Log.d("Диеты: ", Resources.diets.toString())
            }
            catch (e: Exception){
                Log.e("Ошибка: ", e.message.toString())
            }
        }

    }

    fun getCategory(){
        viewModelScope.launch {
            try{
                Resources.categories = Constant.supabase.from("Category").select { "*" }.
                decodeList<Category>() as ArrayList<Category>
                Log.d("Категория: ", Resources.categories.toString())
            }
            catch (e: Exception){
                Log.e("Ошибка: ", e.message.toString())
            }
        }
    }

    fun getIngredients(){
        viewModelScope.launch {
            try{
                Resources.ingredients = Constant.supabase.from("Ingredients").select { "*" }.
                decodeList<Ingredients>() as ArrayList<Ingredients>
                Log.d("Инградиенты: ", Resources.ingredients.toString())
            }
            catch (e: Exception){
                Log.e("Ошибка: ", e.message.toString())
            }
        }

    }


}