package com.example.eatwell.view.mainActivity

import android.util.Log
import android.widget.Toast

import androidx.compose.foundation.background
import androidx.compose.foundation.border
import androidx.compose.foundation.layout.*
import androidx.compose.foundation.shape.RoundedCornerShape
import androidx.compose.foundation.text.KeyboardOptions
import androidx.compose.runtime.*
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.graphics.Color
import androidx.compose.ui.text.input.KeyboardType
import androidx.compose.ui.text.input.PasswordVisualTransformation
import androidx.compose.ui.tooling.preview.Preview
import androidx.compose.ui.unit.dp
import androidx.compose.material3.Text
import androidx.compose.material3.Icon
import androidx.compose.material3.Button
import androidx.compose.material3.ButtonDefaults
import androidx.compose.material3.ExperimentalMaterial3Api
import androidx.compose.material3.IconButton
import androidx.compose.material3.TextField
import androidx.compose.material3.TextFieldDefaults
import androidx.compose.ui.draw.clip
import androidx.compose.ui.platform.LocalContext
import androidx.compose.ui.res.painterResource
import androidx.compose.ui.text.font.FontWeight
import androidx.compose.ui.text.input.VisualTransformation
import androidx.compose.ui.text.style.TextAlign
import androidx.compose.ui.unit.sp
import androidx.navigation.NavHostController
import com.example.eatwell.R
import com.example.eatwell.Resources
import com.example.eatwell.domain.Constant
import com.example.eatwell.model.Roles
import com.example.eatwell.view.MainViewModel
import com.example.eatwell.view.ui.theme.black
import com.example.eatwell.view.ui.theme.fon
import com.example.eatwell.view.ui.theme.knopka
import com.example.eatwell.view.ui.theme.text_1
import com.example.eatwell.view.ui.theme.white
import io.github.jan.supabase.gotrue.auth
import io.github.jan.supabase.postgrest.from
import kotlinx.coroutines.delay
import kotlinx.coroutines.launch

@OptIn(ExperimentalMaterial3Api::class)
//@Preview
@Composable
fun auth2(navController: NavHostController) {
    val viewModel = MainViewModel()
    val email = remember { mutableStateOf("") }
    val password = remember { mutableStateOf("") }
    val scope = rememberCoroutineScope()



    Box(
        modifier = Modifier
            .fillMaxSize()
            .background(fon)
    ) {

        Box(
            modifier = Modifier
                .width(359.dp)
                .height(800.dp)
                .clip(RoundedCornerShape(30.dp))
                .background(white)
                .align(Alignment.Center) //    .shadow(elevation = 10.dp, shape = RoundedCornerShape(30.dp))
                .padding(16.dp)


        ) {
            Column(
                modifier = Modifier
                    .fillMaxSize()
                    .background(white)
                    .padding(top = 30.dp, start = 15.dp, end = 15.dp)
            ) {

                Text(
                    text = "EatWell",
                    fontSize = 20.sp,
                    fontWeight = FontWeight.Bold,
                    color = black,
                    textAlign = TextAlign.Center,
                    modifier = Modifier
                        .fillMaxWidth()
                        .padding(bottom = 80.dp)
                )

                Text(
                    text = "Регистрация    " +
                            " EatWell",
                    fontSize = 30.sp,
                    fontWeight = FontWeight.Bold,
                    color = black,
                    textAlign = TextAlign.Center,
                    modifier = Modifier
                        .fillMaxWidth()
                        .padding(bottom = 80.dp)
                )

                Column(
                    modifier = Modifier
                        .padding(start = 15.dp, end = 15.dp)
                        .fillMaxWidth(),
                    horizontalAlignment = Alignment.Start
                ) {
                    Text(
                        text = "Email",
                        fontSize = 20.sp,
                        fontWeight = FontWeight.Bold,
                        color = black,
                        modifier = Modifier.padding(bottom = 10.dp)
                    )
                    TextField(
                        value = email.value,
                        onValueChange = { newText -> email.value = newText },
                        shape = RoundedCornerShape(15.dp),
                        colors = TextFieldDefaults.textFieldColors(
                            containerColor = fon,
                            focusedIndicatorColor = Color.White,
                            focusedTextColor = Color.Black,
                            unfocusedTextColor = text_1,
                            disabledIndicatorColor = Color.Transparent,
                            unfocusedIndicatorColor = Color.Transparent,
                            cursorColor = text_1,
                            disabledPlaceholderColor = text_1,
                            focusedPlaceholderColor = text_1,
                            unfocusedPlaceholderColor = text_1
                        ),
                        keyboardOptions = KeyboardOptions(keyboardType = KeyboardType.Email),
                        modifier = Modifier
                            .fillMaxWidth()
                            .border(
                                width = 2.dp,
                                shape = RoundedCornerShape(15.dp),
                                color = fon
                            )
                            .height(55.dp),
                        placeholder = { Text("Email") },
                        singleLine = true,
                    )

                    //2
                    Spacer(modifier = Modifier.height(15.dp))

                    var passwordVisibility by remember { mutableStateOf(false) }

                    Text(
                        text = "Password",
                        fontSize = 20.sp,
                        fontWeight = FontWeight.Bold,
                        color = black,
                        modifier = Modifier.padding(bottom = 10.dp)
                    )
                    TextField(
                        value = password.value,
                        visualTransformation = if (passwordVisibility) VisualTransformation.None else PasswordVisualTransformation(),
                        trailingIcon = {
                            IconButton(onClick = {
                                passwordVisibility = !passwordVisibility
                            }) {
                                if (passwordVisibility) {
                                    Icon(
                                        painter = painterResource(id = R.drawable.baseline_person_24),
                                        contentDescription = ""
                                    )
                                } else {
                                    Icon(
                                        painter = painterResource(id = R.drawable.baseline_person_off_24),
                                        contentDescription = ""
                                    )
                                }
                            }
                        },
                        onValueChange = { newText -> password.value = newText },
                        shape = RoundedCornerShape(15.dp),
                        colors = TextFieldDefaults.textFieldColors(
                            containerColor = fon,
                            focusedIndicatorColor = Color.White,
                            focusedTextColor = Color.Black,
                            unfocusedTextColor = text_1,
                            disabledIndicatorColor = Color.Transparent,
                            unfocusedIndicatorColor = Color.Transparent,
                            cursorColor = text_1,
                            disabledPlaceholderColor = text_1,
                            focusedPlaceholderColor = text_1,
                            unfocusedPlaceholderColor = text_1
                        ),
                        modifier = Modifier
                            .fillMaxWidth()
                            .border(
                                width = 2.dp,
                                shape = RoundedCornerShape(15.dp),
                                color = fon
                            )
                            .height(55.dp),
                        placeholder = { Text("Введите пароль") },
                        singleLine = true,
                    )
                    Spacer(modifier = Modifier.height(30.dp))

                    val context = LocalContext.current

                    Button(
                        onClick = {
                            viewModel.onSignUpEmail(email.value, password.value)

                            navController.navigate("Auth")


                        }, Modifier
                            .fillMaxWidth()
                            .padding(vertical = 8.dp, horizontal = 1.dp)
                            .height(55.dp)
                            .background(Color.Transparent),
                        shape = RoundedCornerShape(20.dp),


                        colors = ButtonDefaults.buttonColors(containerColor = knopka)
                    ) {
                        Text(
                            "Регистрация",
                            fontSize = 20.sp,
                            color = white,
                            fontWeight = FontWeight.SemiBold
                        )
                    }
                }
            }
        }
    }
}