package com.example.eatwell.view.mainActivity

import android.util.Log
import android.widget.Toast
import androidx.activity.compose.rememberLauncherForActivityResult
import androidx.compose.foundation.Image
import androidx.compose.foundation.background
import androidx.compose.foundation.layout.Box
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.foundation.layout.height
import androidx.compose.foundation.layout.padding
import androidx.compose.foundation.layout.width
import androidx.compose.foundation.shape.RoundedCornerShape
import androidx.compose.material3.ExperimentalMaterial3Api
import androidx.compose.runtime.Composable
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.draw.clip
import androidx.compose.ui.tooling.preview.Preview
import androidx.compose.ui.unit.dp
import com.example.eatwell.view.ui.theme.fon
import com.example.eatwell.view.ui.theme.white
import androidx.compose.foundation.clickable
import androidx.compose.foundation.layout.*
import androidx.compose.foundation.lazy.LazyColumn
import androidx.compose.foundation.lazy.LazyRow
import androidx.compose.foundation.lazy.items
import androidx.compose.foundation.shape.CircleShape
import androidx.compose.material.*
import androidx.compose.material.icons.Icons
import androidx.compose.material.icons.filled.ArrowDropDown
import androidx.compose.material.icons.filled.DateRange
import androidx.compose.material.icons.filled.Home
import androidx.compose.material.icons.filled.Lock
import androidx.compose.material.icons.filled.MoreVert
import androidx.compose.material.icons.filled.ShoppingCart
import androidx.compose.material3.Divider
import androidx.compose.material3.DropdownMenu
import androidx.compose.material3.DropdownMenuItem


import androidx.compose.runtime.*
import androidx.compose.ui.graphics.Color
import androidx.compose.ui.text.font.FontWeight
import androidx.compose.ui.unit.dp
import androidx.compose.ui.unit.sp
import androidx.compose.material3.Text
import androidx.compose.material3.Icon
import androidx.compose.material3.IconButton
import androidx.compose.ui.graphics.vector.ImageVector
import androidx.compose.ui.platform.LocalContext
import androidx.compose.ui.platform.testTag
import androidx.compose.ui.res.painterResource
import androidx.compose.ui.res.vectorResource
import androidx.compose.ui.text.font.FontFamily
import androidx.compose.ui.text.font.FontWeight.Companion.Bold
import androidx.compose.ui.text.style.TextAlign
import androidx.navigation.NavHostController
import coil.compose.rememberImagePainter
import com.example.eatwell.R
import com.example.eatwell.Resources
import com.example.eatwell.domain.Constant
import com.example.eatwell.model.Category
import com.example.eatwell.model.Diets
import com.example.eatwell.model.Recipes
import com.example.eatwell.view.MainViewModel
import com.example.eatwell.view.ui.theme.text_1
import io.github.jan.supabase.gotrue.auth

var  dietId: Int = 0
var categoryId: Int = 0
var flag: Boolean = false;



@OptIn(ExperimentalMaterial3Api::class)
//@Preview(showBackground = true)
@Composable
fun home(navController: NavHostController) {
    var categoryExpanded by remember { mutableStateOf(false) }
    var expanded by remember { mutableStateOf(false) }
    var expandedCat by remember { mutableStateOf(false) }
    var selectedOption: String
    for (i in 0..Resources.recipes.size-1){
        Resources.chosenRecipes.add(Resources.recipes.get(i))
    }

    Log.d("Диеты home: ", Resources.diets.toString())

    Box(
        modifier = Modifier
            .fillMaxSize()
            .background(fon)
            .padding(top = 20.dp, start = 15.dp, end = 15.dp)
    ) {
        Box(
            modifier = Modifier
                .fillMaxSize()
                .background(fon)
        )
        Box(
            modifier = Modifier
                .width(359.dp)
                .height(730.dp)
                .clip(RoundedCornerShape(30.dp))
                .background(white)
                .align(Alignment.TopCenter) //   .shadow(elevation = 10.dp, shape = RoundedCornerShape(30.dp))
                .padding(16.dp)


        ) {
            Column(
                modifier = Modifier
                    .fillMaxSize()
                    .background(white)
                    .padding(top = 50.dp, start = 15.dp, end = 15.dp)
            ) {
                Row(
                    modifier = Modifier.fillMaxWidth(),
                    horizontalArrangement = Arrangement.SpaceBetween,
                    verticalAlignment = Alignment.CenterVertically
                ) {

                    Box(
                        modifier = Modifier
                            .width(130.dp)
                            .height(40.dp)
                            .clip(RoundedCornerShape(15.dp))
                            .background(fon)
                            .clickable { categoryExpanded = !categoryExpanded }
                            .padding(25.dp, 10.dp)
                            .testTag("categoryChoose")
                    ) {
                        Row(verticalAlignment = Alignment.CenterVertically) {
                            Text(
                                text = "Диета",
                                fontSize = 16.sp,
                                fontWeight = FontWeight.Bold,
                                color = text_1
                            )
                            IconButton(onClick = { expanded = true }) {
                                Icon(
                                    painter = painterResource(id = R.drawable.img_5),
                                    contentDescription = "Показать меню",
                                    tint = text_1
                                )
                            }
                            DropdownMenu(
                                expanded = expanded,
                                onDismissRequest = {
                                    expanded = false
                                }
                            ) {

                                Resources.diets.forEach { diet ->
                                    DropdownMenuItem(
                                        text = { Text(diet.name) },
                                        onClick = {
                                            selectedOption = diet.name
                                            dietId = diet.id
                                            defineRecipes()
                                            expanded = false
                                        }
                                    )
                                }
                            }
                        }
                    }
                        Box(
                            modifier = Modifier
                                .width(130.dp)
                                .height(40.dp)
                                .clip(RoundedCornerShape(15.dp))
                                .background(fon)
                                .clickable { categoryExpanded = !categoryExpanded }
                                .padding(10.dp)
                                .testTag("categoryChoose")
                        ) {
                            Row(
                                verticalAlignment = Alignment.CenterVertically
                            ) {
                                Text(
                                    text = "Категория",
                                    fontSize = 16.sp,
                                    fontWeight = FontWeight.Bold,
                                    color = text_1
                                )
                                Spacer(modifier = Modifier.width(8.dp))
                                IconButton(onClick = { expandedCat = true }) {
                                    Icon(
                                        painter = painterResource(id = R.drawable.img_5),
                                        contentDescription = "Показать меню",
                                        tint = text_1
                                    )
                                }
                                DropdownMenu(
                                    expanded = expandedCat,
                                    onDismissRequest = { expandedCat = false }
                                ) {
                                    for (i in 0..Resources.categories.size - 1) {
                                        Text(
                                            text = Resources.categories.get(i).name,
                                            fontSize = 18.sp,
                                            modifier = Modifier.padding(10.dp)
                                        )
                                    }
                                }
                            }
                        }
                    }

                    Column(
                        modifier = Modifier
                            .size(width = 400.dp, height = 750.dp)
                            .background(Color.LightGray)
                    ) {

                        LazyColumn(
                            modifier = Modifier.fillMaxSize()
                        ) {
                            var list: MutableList<Recipes> = Resources.chosenRecipes

                            items(list.size) { itemId ->
                                Image(
                                    painter = rememberImagePainter(
                                        list.get(
                                            itemId
                                        ).image
                                    ),
                                    contentDescription = "Image in LazyRow - $itemId",
                                    modifier = Modifier
                                        .padding(
                                            top = 10.dp,
                                            bottom = 10.dp,
                                            start = 7.5.dp,
                                            end = 7.5.dp
                                        )
                                        .fillMaxWidth()
                                        .height(100.dp)
                                )
                                Text(
                                    modifier = Modifier
                                        .fillMaxWidth()
                                        .padding(top = 7.5.dp),
                                    text = list.get(itemId).name,
                                    color = Color.Black,
                                    fontSize = 20.sp,
                                    fontWeight = FontWeight.Bold,
                                    fontFamily = FontFamily.Monospace,
                                    textAlign = TextAlign.Left
                                )

                                Text(
                                    modifier = Modifier
                                        .fillMaxWidth()
                                        .padding(top = 7.5.dp),
                                    text = list.get(itemId).calories,
                                    color = Color.Gray,
                                    fontSize = 15.sp,
                                    fontWeight = FontWeight.Bold,
                                    fontFamily = FontFamily.Monospace,
                                    textAlign = TextAlign.Left
                                )
                            }
                        }
                    }

                }
            }
        }

        Box(
            modifier = Modifier
                .fillMaxSize()
                .padding(20.dp)
        ) {
            Box(
                modifier = Modifier
                    .width(359.dp)
                    .wrapContentHeight()
                    .clip(RoundedCornerShape(30.dp))
                    .background(white)
                    .align(Alignment.BottomCenter)
                    .padding(bottom = 50.dp)
            ) {

                // Черная линия
                Divider(
                    modifier = Modifier
                        .fillMaxWidth()
                        .height(1.dp)
                        .background(fon)
                )
                Row(
                    modifier = Modifier
                        .fillMaxWidth()
                        .padding(top = 9.dp),
                    horizontalArrangement = Arrangement.SpaceAround,
                    verticalAlignment = Alignment.CenterVertically
                ) {
                    Column(
                        horizontalAlignment = Alignment.CenterHorizontally,

                        ) {
                        Icon(
                            painter = painterResource(id = R.drawable.img),
                            contentDescription = "Home",
                            tint = Color.Black,
                            modifier = Modifier.size(25.dp)
                        )
                        Spacer(modifier = Modifier.height(9.dp))
                        Text("HOME", color = Color.Black)
                    }

                    Column(
                        horizontalAlignment = Alignment.CenterHorizontally
                    ) {
                        IconButton(
                            onClick = {
                                navController.navigate("MyPlan")
                                {
                                }
                            }, modifier = Modifier.size(32.dp)
                        ) {
                            Icon(
                                painter = painterResource(id = R.drawable.img_1),
                                contentDescription = "My Plan",
                                tint = text_1,
                                modifier = Modifier.size(25.dp)
                            )
                        }
                        Spacer(modifier = Modifier.height(9.dp))
                        Text("MY PLAN", color = text_1)
                    }
                    Column(
                        horizontalAlignment = Alignment.CenterHorizontally
                    ) {
                        IconButton(
                            onClick = {
                                navController.navigate("Fridge")
                                {
                                }
                            }, modifier = Modifier.size(32.dp)
                        ) {
                            Icon(
                                painter = painterResource(id = R.drawable.img_2),
                                contentDescription = "Fridge",
                                tint = text_1,
                                modifier = Modifier.size(28.dp)
                            )
                        }
                        Spacer(modifier = Modifier.height(9.dp))
                        Text("FRIGE", color = text_1)
                    }
                    Column(
                        horizontalAlignment = Alignment.CenterHorizontally
                    ) {
                        IconButton(
                            onClick = {
                                navController.navigate("Auth")
                                {
                                }
                            }, modifier = Modifier.size(32.dp)
                        ) {
                            Icon(
                                painter = painterResource(id = R.drawable.img_3),
                                contentDescription = "Log Out",
                                tint = text_1,
                                modifier = Modifier.size(28.dp)
                            )
                        }
                        Spacer(modifier = Modifier.height(9.dp))
                        Text("LOG OUT", color = text_1)
                    }
                }
            }
        }
    }

fun defineRecipes(){
    Resources.chosenRecipes.clear()
    for(i in 0..Resources.recipes.size-1){
        if(Resources.recipes.get(i).diets == dietId && Resources.recipes.get(i).category == categoryId){
            Resources.chosenRecipes.add(Resources.recipes.get(i))
        }
    }
}

