package com.example.eatwell.view.mainActivity

import android.os.Bundle
import android.util.Log
import androidx.activity.ComponentActivity
import androidx.activity.compose.setContent
import androidx.activity.enableEdgeToEdge
import androidx.compose.foundation.layout.Arrangement
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.foundation.layout.padding
import androidx.compose.material3.Scaffold
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.tooling.preview.Preview
import androidx.lifecycle.viewModelScope
import androidx.navigation.NavHostController
import androidx.navigation.compose.NavHost
import androidx.navigation.compose.composable
import androidx.navigation.compose.rememberNavController
import com.example.eatwell.Resources
import com.example.eatwell.model.Diets
import com.example.eatwell.view.MainViewModel
import com.example.eatwell.view.ui.theme.EatWellTheme
import io.github.jan.supabase.gotrue.Auth

class MainActivity : ComponentActivity() {
   // lateinit var navController:NavHostController;
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        enableEdgeToEdge()
//        val viewModel = MainViewModel()
//            //        viewModel.onSignUpEmail("Kasatkina05@icloud.com", "kasatkina99")
//      viewModel.onSignInEmailPassword("Kasatkina05@icloud.com", "kasatkina99")
//        viewModel.getRecipes(2,4)
//        viewModel.getDiets()
//        viewModel.getCategory()
//        viewModel.getIngredients()
        Resources.viewModel.getDiets()
        Resources.viewModel.getCategory()
        Resources.viewModel.getRecipes()
        Resources.viewModel.getIngredients()
        Log.d("Диеты: ", Resources.diets.toString())

        setContent {
            EatWellTheme {
                Column(
                    verticalArrangement = Arrangement.Center,
                    horizontalAlignment = Alignment.CenterHorizontally
                ){}
            }
            val navController = rememberNavController()
            NavHost(navController = navController, startDestination = "Start") {    composable("Start") {
                Start(navController)    }
                composable("auth") {
                    auth(navController)
                }
                composable("home") {
                    home(navController)    }
                composable("auth2") {
                    auth2(navController)    }
                composable("fridge") {
                    fridge(navController)
                }
                composable("myplan") {
                    myplan(navController)    }
                composable("recept") {
                    recept(navController)
                }
                composable("ingredients") {
                    ingredients(navController)    }
                composable("dish") {
                    dish(navController)
                }
            }
        }
    }


}

//@Composable
//fun Greeting(name: String, modifier: Modifier = Modifier) {
//    Text(
//        text = "Hello $name!",
//        modifier = modifier
//    )
//}
//
//@Preview(showBackground = true)
//@Composable
//fun GreetingPreview() {
//    EatWellTheme {
//        Greeting("Android")
//    }
//}