package com.example.eatwell.view.mainActivity

import android.graphics.drawable.Drawable
import android.os.Build
import androidx.annotation.RequiresApi
import androidx.compose.foundation.background
import androidx.compose.foundation.layout.Box
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.foundation.layout.height
import androidx.compose.foundation.layout.padding
import androidx.compose.foundation.layout.width
import androidx.compose.foundation.shape.RoundedCornerShape
import androidx.compose.material3.ExperimentalMaterial3Api
import androidx.compose.runtime.Composable
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.draw.clip
import androidx.compose.ui.tooling.preview.Preview
import androidx.compose.ui.unit.dp
import com.example.eatwell.view.ui.theme.fon
import com.example.eatwell.view.ui.theme.white
import androidx.compose.foundation.clickable
import androidx.compose.foundation.layout.*
import androidx.compose.foundation.lazy.LazyColumn
import androidx.compose.foundation.lazy.items
import androidx.compose.material.*
import androidx.compose.material.icons.Icons
import androidx.compose.material.icons.filled.ArrowDropDown
import androidx.compose.material.icons.filled.DateRange
import androidx.compose.material.icons.filled.Home
import androidx.compose.material.icons.filled.Lock
import androidx.compose.material.icons.filled.ShoppingCart
import androidx.compose.material3.Divider
import androidx.compose.material3.DropdownMenu
import androidx.compose.material3.DropdownMenuItem
import androidx.compose.runtime.*
import androidx.compose.ui.graphics.Color
import androidx.compose.ui.text.font.FontWeight
import androidx.compose.ui.unit.dp
import androidx.compose.ui.unit.sp
import androidx.compose.material3.Text
import androidx.compose.material3.Icon
import androidx.compose.ui.graphics.vector.ImageVector
import androidx.compose.ui.platform.LocalContext
import androidx.compose.ui.res.painterResource
import androidx.compose.ui.res.vectorResource
import androidx.compose.ui.text.style.TextAlign
import com.example.eatwell.R
import com.example.eatwell.domain.Constant
import com.example.eatwell.model.Recipes
import com.example.eatwell.view.ui.theme.black
import com.example.eatwell.view.ui.theme.text_1
import io.github.jan.supabase.gotrue.auth
import java.time.LocalDate
import java.time.format.DateTimeFormatter
import androidx.compose.material3.Button


import androidx.compose.foundation.background
import androidx.compose.foundation.border
import androidx.compose.foundation.layout.Box
import androidx.compose.foundation.layout.Column
import androidx.compose.foundation.layout.fillMaxSize
import androidx.compose.foundation.layout.height
import androidx.compose.foundation.layout.padding
import androidx.compose.foundation.layout.width
import androidx.compose.ui.draw.clip
import androidx.compose.ui.unit.dp
import com.example.eatwell.view.ui.theme.fon
import com.example.eatwell.view.ui.theme.white
import androidx.compose.foundation.clickable
import androidx.compose.foundation.layout.*
import androidx.compose.foundation.lazy.LazyColumn
import androidx.compose.foundation.lazy.grid.GridCells
import androidx.compose.foundation.lazy.grid.LazyVerticalGrid
import androidx.compose.foundation.lazy.grid.itemsIndexed
import androidx.compose.foundation.lazy.items
import androidx.compose.foundation.shape.CircleShape
import androidx.compose.material.*
import androidx.compose.material.icons.filled.ArrowBack
import androidx.compose.material.icons.filled.ArrowDropDown
import androidx.compose.material.icons.filled.ArrowForward
import androidx.compose.material.icons.filled.DateRange
import androidx.compose.material.icons.filled.Home
import androidx.compose.material.icons.filled.Lock
import androidx.compose.material.icons.filled.ShoppingCart
import androidx.compose.material3.ButtonDefaults
import androidx.compose.material3.Divider
import androidx.compose.material3.DropdownMenu
import androidx.compose.material3.DropdownMenuItem
import androidx.compose.runtime.*
import androidx.compose.ui.unit.dp
import androidx.compose.ui.unit.sp
import androidx.compose.material3.Text
import androidx.compose.material3.Icon
import androidx.compose.material3.IconButton
import androidx.compose.ui.graphics.Brush
import androidx.compose.ui.graphics.painter.BitmapPainter
import androidx.compose.ui.platform.LocalContext
import androidx.compose.ui.res.painterResource
import androidx.compose.ui.res.vectorResource
import androidx.core.content.ContextCompat
import androidx.core.graphics.drawable.toBitmap
import androidx.navigation.NavController
import androidx.navigation.NavHostController
import com.example.eatwell.view.ui.theme.knopka
import com.example.eatwell.view.ui.theme.text_1
import io.github.jan.supabase.gotrue.auth

@RequiresApi(Build.VERSION_CODES.O)
@OptIn(ExperimentalMaterial3Api::class)
//@Preview
@Composable
fun myplan(navController: NavHostController) {
    var selectedDates by remember { mutableStateOf(mutableSetOf<LocalDate>()) }
    var currentMonth by remember { mutableStateOf(LocalDate.now().monthValue) }

    val daysInMonth = getDaysInMonth(currentMonth, LocalDate.now().year)
    val firstDayOfMonth = LocalDate.of(LocalDate.now().year, currentMonth, 1).dayOfWeek.value
    Box(
        modifier = Modifier
            .fillMaxSize()
            .background(fon)
    ) {
        Box(
            modifier = Modifier
                .fillMaxSize()
                .background(fon)
        )
        Box(
            modifier = Modifier
                .width(359.dp)
                .height(800.dp)
                .clip(RoundedCornerShape(30.dp))
                .background(white)
                .align(Alignment.Center) //   .shadow(elevation = 10.dp, shape = RoundedCornerShape(30.dp))
                .padding(16.dp)


        ) {
            Column(
                modifier = Modifier
                    .fillMaxSize()
                    .background(white)
                    .padding(top = 10.dp, start = 15.dp, end = 15.dp)
            ) {
                Text(
                    text = "Календарь",
                    fontSize = 20.sp,
                    fontWeight = FontWeight.Bold,
                    color = black,
                    textAlign = TextAlign.Center,
                    modifier = Modifier
                        .fillMaxWidth()
                        .padding(bottom = 80.dp)
                )
                Text(
                    text = "Отметьте дни, когда вы следуете своему плану  ",
                    fontSize = 20.sp,
                    fontWeight = FontWeight.Bold,
                    color = black,
                    textAlign = TextAlign.Left,
                    modifier = Modifier
                        .fillMaxWidth()
                        .padding(bottom = 30.dp)
                )

                Row(
                    modifier = Modifier
                        .fillMaxWidth()
                        .padding(16.dp),
                    horizontalArrangement = Arrangement.SpaceBetween,
                    verticalAlignment = Alignment.CenterVertically
                ) {
                    IconButton(onClick = {

                        currentMonth = (currentMonth - 1).takeIf { it > 0 } ?: 12

                    }) {
                        Icon(Icons.Filled.ArrowBack, contentDescription = "Previous Month")
                    }

                    Text(
                        text = LocalDate.of(LocalDate.now().year, currentMonth, 1)
                            .format(DateTimeFormatter.ofPattern("MMMM yyyy")),
                        fontWeight = FontWeight.Bold,
                        fontSize = 20.sp
                    )

                    IconButton(onClick = {
                        currentMonth = (currentMonth + 1).takeIf { it <= 12 } ?: 1

                    }) {
                        Icon(Icons.Filled.ArrowForward, contentDescription = "Next Month")
                    }
                }
                // Календарь
                LazyVerticalGrid(
                    columns = GridCells.Fixed(7),
                    verticalArrangement = Arrangement.spacedBy(2.dp),
                    horizontalArrangement = Arrangement.spacedBy(2.dp),
                    modifier = Modifier.padding(16.dp)
                ) {
                    itemsIndexed(listOf("Пн", "Вт", "Ср", "Чт", "Пт", "Сб", "Вс")) { index, day ->
                        Text(
                            text = day,
                            modifier = Modifier
                                .fillMaxWidth()
                                .padding(4.dp),
                            textAlign = TextAlign.Center,
                            fontWeight = FontWeight.Bold
                        )
                    }
                    // Дни месяца
                    items(daysInMonth + firstDayOfMonth - 1) { index ->
                        val day = index - (firstDayOfMonth - 1) + 1
                        if (day > 0) {
                            val date = LocalDate.of(LocalDate.now().year, currentMonth, day)
                            val isSelected = selectedDates.contains(date)


                            Box(
                                modifier = Modifier
                                    .fillMaxWidth()
                                    .padding(4.dp)
                                    .clip(CircleShape)
                                    .clickable {
                                        selectedDates = if (isSelected) {
                                            selectedDates - date
                                        } else {
                                            selectedDates + date
                                        }.toMutableSet()
                                    }
                                    .then(if (isSelected) Modifier.background(knopka) else Modifier),
                                contentAlignment = Alignment.Center
                            ) {
                                Text(text = day.toString())
                            }
                        } else {
                            Box(modifier = Modifier.fillMaxWidth().padding(4.dp))
                        }
                    }
                }
                Row(
                    modifier = Modifier
                        .fillMaxWidth()
                        .padding(10.dp),
                    horizontalArrangement = Arrangement.SpaceBetween
                ) {
                    repeat(12) { index ->
                        Box(
                            modifier = Modifier
                                .size(5.dp)
                                .background(if (currentMonth == (index + 1)) Color.Green else Color.LightGray)
                                .clickable { currentMonth = (index + 1) }
                        )
                    }
                }}


                //вот
                Column(
                    modifier = Modifier
                        .fillMaxSize()
                        .padding(top = 710.dp, start = 15.dp, end = 15.dp)
                ) {
                    Box(
                        modifier = Modifier
                            .fillMaxWidth()
                            .padding(bottom = 1.dp)
                    ) {
                        Divider(
                            modifier = Modifier
                                .fillMaxWidth()
                                .height(1.dp)
                                .background(fon)
                        )
                        Row(
                            modifier = Modifier
                                .fillMaxWidth()
                                .padding(top = 8.dp),
                            horizontalArrangement = Arrangement.SpaceBetween,
                            verticalAlignment = Alignment.CenterVertically
                        ) {
                            Column(
                                horizontalAlignment = Alignment.CenterHorizontally
                            ) {
                                IconButton(
                                    onClick = {
                                        navController.navigate("Home")
                                        {
                                        }
                                    }, modifier = Modifier.size(32.dp)
                                ) {
                                    Icon(
                                        painter = painterResource(id = R.drawable.img),
                                        contentDescription = "HOME",
                                        tint = text_1,
                                        modifier = Modifier.size(25.dp)
                                    )
                                }
                                Spacer(modifier = Modifier.height(4.dp))
                                Text("HOME", color = text_1)
                            }

                            Column(
                                horizontalAlignment = Alignment.CenterHorizontally
                            ) {
                                Icon(
                                    painter = painterResource(id = R.drawable.img_1),
                                    contentDescription = "My Plan",
                                    tint = Color.Black,
                                            modifier = Modifier.size(25.dp)
                                )
                                Spacer(modifier = Modifier.height(9.dp))
                                Text("MY PLAN", color = Color.Black)
                            }

                            Column(
                                horizontalAlignment = Alignment.CenterHorizontally
                            ) {
                                IconButton(
                                    onClick = {
                                        navController.navigate("Fridge")
                                        {
                                        }
                                    }, modifier = Modifier.size(32.dp)
                                ) {
                                    Icon(
                                        painter = painterResource(id = R.drawable.img_2),
                                        contentDescription = "Fridge",
                                        tint = text_1,
                                        modifier = Modifier.size(28.dp)
                                    )
                                }
                                Spacer(modifier = Modifier.height(4.dp))
                                Text("FRIGE", color = text_1)
                            }
                            Column(
                                horizontalAlignment = Alignment.CenterHorizontally
                            ) {
                                IconButton(
                                    onClick = {
                                        navController.navigate("Auth")
                                        {
                                        }
                                    }, modifier = Modifier.size(32.dp)
                                ) {
                                    Icon(
                                        painter = painterResource(id = R.drawable.img_3),
                                        contentDescription = "Log Out",
                                        tint = text_1,
                                        modifier = Modifier.size(28.dp)
                                    )
                                }
                                Spacer(modifier = Modifier.height(4.dp))
                                Text("LOG OUT", color = text_1)
                            }
                        }
                    }
                }
            }
        }
    }



// Функция для получения количества дней в месяце
@RequiresApi(Build.VERSION_CODES.O)
fun getDaysInMonth(month: Int, year: Int): Int {
    return LocalDate.of(year, month, 1).lengthOfMonth()
}

@RequiresApi(Build.VERSION_CODES.O)
@Composable
fun CalendarDay(date: LocalDate, isSelected: Boolean, onDateClick: (LocalDate) -> Unit) {
    Button(
        onClick = { onDateClick(date) },
        modifier = Modifier
            .width(36.dp) // Adjust width as needed
            .height(36.dp) // Adjust height as needed
            .padding(2.dp)
            .clickable { onDateClick(date) },
        colors = ButtonDefaults.buttonColors(
            containerColor = if (isSelected) Color(0xFFFFA500) else Color.White
        ),
        shape = CircleShape
    ) {
        Text(
            text = date.dayOfMonth.toString(),
            modifier = Modifier.padding(2.dp),
            color = if (isSelected) Color.White else Color.Black
        )
    }
}
