package com.example.eatwell.view.mainActivity

import androidx.compose.runtime.Composable
import androidx.compose.runtime.LaunchedEffect
import androidx.compose.runtime.MutableState
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.remember
import androidx.compose.runtime.rememberCoroutineScope
import com.example.eatwell.domain.Constant

import io.github.jan.supabase.gotrue.auth
import io.github.jan.supabase.postgrest.from
import kotlinx.coroutines.launch
import com.example.eatwell.model.Roles

//возвращает роль пользователя извлеченную из таблицы role в базе данных
@Composable
fun getRole(): String{
    val scope = rememberCoroutineScope()

    var role = remember { mutableStateOf("") }
    LaunchedEffect(Unit) {
        scope.launch {
            val rolesList = Constant.supabase.from("Roles").select() {//запрос к таблице в базе
                filter {//фильтруем по соответствию текущ авторизированного пользователя
                    Roles::user_id eq Constant.supabase.auth.currentUserOrNull()!!.id
                }
            }.decodeList<Roles>()
            if (rolesList.count() != 0){ //найдет ли хотя бы один резулттат
                role.value = rolesList[0].title

            }
        }
    }
    return role.value
}
